;EasyCodeName=Module1,1
.686 ; create 32 bit code
.Model flat, StdCall  ;32 bit memory model
Option CaseMap :none  ; case sensitive

;The MASM32 Runtime Library include file.
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include	\masm32\include\masm32rt.inc
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

.Code

start:
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	Call Main
	inkey        ; pause the screen while waiting for user to press any key
	             ; to continue
    exit
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

performPrimeFactorization Proto:DWord

Main Proc
	Local WantContinue:DWord
	Local Number:DWord
	; WantContinue is the sentinel loop variable to continue or exit loop
	; Number is the integer to be factored
    ;---------------------------------------------------------------------------

    ; Eax, Ebx, Edx, Edi, Esi are registers

    Mov WantContinue, 0   ; initialize WantContinue = 0 for while loop

    .While ((WantContinue >= 0) && (WantContinue < -1))
    ; while WantContinue is greater than or equal to 0 And
    ; WantContinue is less than -1 do
       print chr$(13, 10)  ; a carriage return line feed will be outputted to
                           ; the screen
       print chr$("A prime Number is a positive integer divisible only", 13, 10)
       print chr$("by itself and 1.", 13, 10)
       print chr$("For example, 2 is a prime Number.", 13, 10, 13, 10)
       print chr$("Prime Factorization means factoring out the positive integer", 13, 10)
       print chr$("into primes numbers which are multiples of the integer", 13, 10)
       print chr$("to the right of the equal sign.", 13, 10, 13, 10)
       print chr$("Multiplying each prime Number to the right of the equal", 13, 10)
       print chr$("sign gives you the positive integer to the left of the", 13, 10)
       print chr$("equal sign.", 13, 10)
       print chr$("For example, the prime factorization for 3, is  3 = 3", 13, 10)
       print chr$("For example, the prime factorization for 6, is  6 = 2 x 3", 13, 10, 13, 10)
       print chr$(13, 10)

       Mov Number, sval(input("Enter an integer value for Number : "))
       Invoke performPrimeFactorization, Number
       Mov WantContinue, sval(input("Enter -1 to quit program : "))
       print chr$(13, 10)
       Invoke ClearScreen
    .EndW
  print chr$(13, 10)
  Ret
Main EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  performPrimeFactorization procedure will factor a positive integer greater  <<
;<<  than or equal to 2 into prime factors and display it to the screen          <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

performPrimeFactorization Proc Uses Esi Edi Number:DWord
	; preserve Esi And Edi registers

	Local moveSpaceCounter:DWord

	Local Remainder:DWord
	Local Quotient:DWord
	Local primeCounter:DWord
	Local PrimeFactor[1024]:Byte
	Local Factor:DWord
	; moveSpaceCounter counts number of spaces that is needed to be outputted to
	;   screen
	; primeCounter counts the number of prime factors to be factored out for the
	;   positive integer
	; PrimeFactor is the string containing the factored primes of the user's
	;   integer
	; Factor is one of the prime factors of the user's number

       print chr$(13, 10)
       Mov Factor, 2       ; set Factor = 2
       Mov Esi, Number     ; set Esi = Number

       .If ((Esi <= SDWord Ptr 1) || (Esi > 10000000)) ; if (Number <= 1)
       	 print chr$(13, 10)                            ; Or (Number > 10000000)
       	 print chr$("Invalid integer entered!", 13, 10)
       	 print chr$("An integer must be between 2 and 10000000!", 13, 10)
       	 print chr$(13, 10, 13, 10)
       .ElseIf ((Esi > 1) && (Esi <= 10000000)) ;(Number > 1) and (Number <= 10000000)
       	 Mov moveSpaceCounter, 0  ; set moveSpaceCounter = 0

         ; the following if else statement output the format to screen

         .If ((Esi >= 2) && (Esi <= 9))    ; if Esi greater Or equal to 2 And
                                           ; Esi less than or equal to 9
         	.While (moveSpaceCounter <= 6)  ; while moveSpaceCounter less than or
         		                            ; equal to 6
         		                            ; will output 7 spaces to the screen
                print chr$(" ")             ; will output a space
                Add moveSpaceCounter, 1   ; moveSpaceCounter = moveSpaceCounter + 1
            .EndW
         .ElseIf ((Esi > 9) && (Esi <= 99)) ; if Esi greater than 9 And
         	                                ; Esi less than or equal to 99
            .While (moveSpaceCounter <= 6)  ; while moveSpaceCounter less than or
            	                            ; equal to 6
            	                            ; will output 7 spaces to the screen
                print chr$(" ")             ; will output a space
                Add moveSpaceCounter, 1   ; moveSpaceCounter = moveSpaceCounter + 1
            .EndW
         .ElseIf ((Esi > 99) && (Esi <= 999)) ; if Esi greater than 99 And
         	                                  ; Esi less than or equal to 999
            .While (moveSpaceCounter <= 5)  ; while moveSpaceCounter less than or
            	                            ; equal to 5
            	                            ; will output 6 spaces to the screen
                print chr$(" ")             ; will output a space
                Add moveSpaceCounter, 1   ; moveSpaceCounter = moveSpaceCounter + 1
            .EndW
         .ElseIf ((Esi > 999) && (Esi <= 9999)) ; if Esi greater than 999 And
         	                                    ; Esi less than or equal to 9999
         	.While (moveSpaceCounter <= 5)  ; while moveSpaceCounter less than or
         		                            ; equal to 5
         		                            ; will output 6 spaces to the screen
                print chr$(" ")             ; will output a space
                Add moveSpaceCounter, 1   ; moveSpaceCounter = moveSpaceCounter + 1
          	.EndW
         .ElseIf ((Esi > 9999) && (Esi <= 99999)) ; if Esi greater than 9999 And
         	                                     ; Esi less than or equal to 99999
         	.While (moveSpaceCounter <= 4)  ; while moveSpaceCounter less than or
         		                            ; equal to 4
         		                            ; will output 5 spaces to the screen
                print chr$(" ")             ; will output a space
                Add moveSpaceCounter, 1   ; moveSpaceCounter = moveSpaceCounter + 1
            .EndW
         .ElseIf ((Esi > 99999) && (Esi <= 999999)) ; if Esi greater than 99999 And
         	                                     ; Esi less than or equal to 999999
         	.While (moveSpaceCounter <= 4)  ; while moveSpaceCounter less than or
         		                            ; equal to 4
         		                            ; will output 5 spaces to the screen
                print chr$(" ")             ; will output a space
                Add moveSpaceCounter, 1   ; moveSpaceCounter = moveSpaceCounter + 1
         	.EndW
         .ElseIf ((Esi > 999999) && (Esi <= 9999999)) ; if Esi greater than 999999
         	                                ; And Esi less than or equal to 9999999
         	.While (moveSpaceCounter <= 3) ; while moveSpaceCounter less than or
         		                           ; equal to 3
         		                           ; will output 4 spaces to the screen
                print chr$(" ")             ; will output a space
                Add moveSpaceCounter, 1   ; moveSpaceCounter = moveSpaceCounter + 1
         	.EndW
         .ElseIf ((Esi > 9999999) && (Esi <= 10000000)) ; if Esi greater than
         	                      ; 9999999 And Esi less than or equal to 10000000
            .While (moveSpaceCounter <= 3)   ; while moveSpaceCounter less than or
            	                             ; equal to 3
            	                             ; will output 4 spaces to the screen
                print chr$(" ")             ; will output a space
                Add moveSpaceCounter, 1   ; moveSpaceCounter = moveSpaceCounter + 1
            .EndW
         .EndIf

       	 print chr$("Prime Factorization for ")
       	 print str$(Esi)
       	 print chr$(13, 10)
       	 print chr$("----------------------------------------", 13, 10)
       	 print chr$(" ")
       	 print str$(Esi)
       	 print chr$(" = ")

       	 Mov PrimeFactor, 0  ; set the PrimeFactor string to empty
       	 Mov primeCounter, 1 ; set primeCounter = 1

         .While Factor <= Esi  ; while Factor less than or equal to (Number = Esi)
       	   Mov Eax, Number     ; set Eax = Number
       	   Mov Ebx, Factor     ; set Ebx = Factor
       	   Cdq                 ; convert to double quad word or 64-bit long word
       	   Div Ebx             ; Eax = Eax / Ebx
       	   Mov Quotient, Eax   ; set Quotient = Eax
       	                       ; Quotient = Number / Factor
       	   Mov Remainder, Edx  ; set Remainder = Edx
       	                       ; Remainder = Number mod Factor

           .If (Remainder == 0)  ; if Remainder equals to zero
           	 .If (primeCounter == 1) ; if primeCounter equals to 1
           	 	Mov Eax, cat$(Addr PrimeFactor, str$(Factor))
           	 	; insert the first prime factor to the PrimeFactor string
           	 .ElseIf (primeCounter > 1) ; if primeCounter greater than 1
           	    Mov Edi, cat$(Addr PrimeFactor, " x ", str$(Factor))
           	    ; concatenate additional prime factors to the PrimeFactor string
           	 .EndIf

           	 Inc primeCounter      ; primeCounter = primeCounter + 1
           	                       ; generate PrimeFactor string by
           	                       ; concatenating prime factors and
           	                       ; adding them to PrimeFactor string
             Mov Edi, Quotient   ; set Edi = Quotient
             Mov Number, Edi     ;  Edi = Number = Quotient
             Mov Eax, Number     ; set Eax = Number
       	     Mov Ebx, Factor     ; set Ebx = Factor
       	     Cdq                 ; convert to double quad word or 64-bit long word
       	     Div Ebx             ; Eax = Eax / Ebx
       	     Mov Quotient, Eax   ; set Quotient = Eax
       	                         ; Quotient = Number / Factor
       	     Mov Remainder, Edx  ; set Remainder = Edx
       	                         ; Remainder = Number mod Factor
           .ElseIf
          	 Inc Factor   ; Factor = Factor + 1
           .EndIf
         .EndW

         print Addr PrimeFactor, 13, 10, 13, 10, 13, 10  ; print PrimeFactor string
                        ; and output three carriage return line feeds to the screen
         print chr$(13, 10)
         Mov PrimeFactor, 0  ; reinitialize the PrimeFactor string by setting
                             ; this string to empty
       .EndIf
   Ret
performPrimeFactorization EndP
End start

